#ifndef EFL_ORIENTATION_EO_HH
#define EFL_ORIENTATION_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_orientation.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#ifndef EFL_ORIENTATION_FWD_GUARD
#define EFL_ORIENTATION_FWD_GUARD
namespace efl { 
struct Orientation;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Orientation> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Orientation&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Orientation const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Orientation const&> : ::std::true_type {}; } }
#endif

namespace eo_cxx {
namespace efl { 
struct Orientation {
   ::efl::eolian::return_traits<Efl_Orient>::type orientation_get() const;
   ::efl::eolian::return_traits<void>::type orientation_set( ::efl::eolian::in_traits<Efl_Orient>::type dir) const;
   ::efl::eolian::return_traits<Efl_Flip>::type flip_get() const;
   ::efl::eolian::return_traits<void>::type flip_set( ::efl::eolian::in_traits<Efl_Flip>::type flip) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_ORIENTATION_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Orientation *>(this))); }
   operator ::efl::Orientation() const;
   operator ::efl::Orientation&();
   operator ::efl::Orientation const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Orientation> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Orientation const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace efl { 
struct Orientation : private ::efl::eo::concrete
{
   explicit Orientation( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   Orientation(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   explicit Orientation() = default;
   Orientation(Orientation const&) = default;
   Orientation(Orientation&&) = default;
   Orientation& operator=(Orientation const&) = default;
   Orientation& operator=(Orientation&&) = default;
   template <typename Derived>
   Orientation(Derived&& derived
      , typename std::enable_if<
         ::efl::eo::is_eolian_object<Derived>::value
          && std::is_base_of< Orientation, Derived>::value>::type* = 0)
         : ::efl::eo::concrete(derived._eo_ptr()) {}

   ::efl::eolian::return_traits<Efl_Orient>::type orientation_get() const;
   ::efl::eolian::return_traits<void>::type orientation_set( ::efl::eolian::in_traits<Efl_Orient>::type dir) const;
   ::efl::eolian::return_traits<Efl_Flip>::type flip_get() const;
   ::efl::eolian::return_traits<void>::type flip_set( ::efl::eolian::in_traits<Efl_Flip>::type flip) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_ORIENTATION_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Orientation *>(this))); }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Orientation> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Orientation const > operator&() const { return {this}; }
   /// @endcond
   ::efl::eo::wref<Orientation> _get_wref() const { return ::efl::eo::wref<Orientation>(*this); }
   ::efl::eo::concrete const& _get_concrete() const { return *this; }
   ::efl::eo::concrete& _get_concrete() { return *this; }
   using ::efl::eo::concrete::_eo_ptr;
   using ::efl::eo::concrete::_release;
   using ::efl::eo::concrete::_reset;
   using ::efl::eo::concrete::_delete;
   using ::efl::eo::concrete::operator bool;
#ifdef EFL_CXXPERIMENTAL
   const Orientation* operator->() const { return this; }
   Orientation* operator->() { return this; }
   operator Eo*() const { return _eo_ptr(); }
#endif 
   friend bool operator==(Orientation const& lhs, Orientation const& rhs)
   { return lhs._get_concrete() == rhs._get_concrete(); }
   friend bool operator!=(Orientation const& lhs, Orientation const& rhs)
   { return !(lhs == rhs); }
};
static_assert(sizeof(Orientation) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Orientation>::value, "");
} 
#endif
