#ifndef EFL_TEXT_FONT_EO_HH
#define EFL_TEXT_FONT_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_text_font.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#ifndef EFL_TEXT_FONT_FWD_GUARD
#define EFL_TEXT_FONT_FWD_GUARD
namespace efl { 
struct Text_Font;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Text_Font> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Text_Font&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Text_Font const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Text_Font const&> : ::std::true_type {}; } }
#endif

namespace eo_cxx {
namespace efl { 
struct Text_Font {
   ::efl::eolian::return_traits<void>::type font_get( ::efl::eolian::out_traits< ::efl::eina::string_view>::type font,  ::efl::eolian::out_traits<Efl_Font_Size>::type size) const;
   ::efl::eolian::return_traits<void>::type font_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type font,  ::efl::eolian::in_traits<Efl_Font_Size>::type size) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type font_source_get() const;
   ::efl::eolian::return_traits<void>::type font_source_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type font_source) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type font_fallbacks_get() const;
   ::efl::eolian::return_traits<void>::type font_fallbacks_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type font_fallbacks) const;
   ::efl::eolian::return_traits<Efl_Text_Font_Weight>::type font_weight_get() const;
   ::efl::eolian::return_traits<void>::type font_weight_set( ::efl::eolian::in_traits<Efl_Text_Font_Weight>::type font_weight) const;
   ::efl::eolian::return_traits<Efl_Text_Font_Slant>::type font_slant_get() const;
   ::efl::eolian::return_traits<void>::type font_slant_set( ::efl::eolian::in_traits<Efl_Text_Font_Slant>::type style) const;
   ::efl::eolian::return_traits<Efl_Text_Font_Width>::type font_width_get() const;
   ::efl::eolian::return_traits<void>::type font_width_set( ::efl::eolian::in_traits<Efl_Text_Font_Width>::type width) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type font_lang_get() const;
   ::efl::eolian::return_traits<void>::type font_lang_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type lang) const;
   ::efl::eolian::return_traits<Efl_Text_Font_Bitmap_Scalable>::type font_bitmap_scalable_get() const;
   ::efl::eolian::return_traits<void>::type font_bitmap_scalable_set( ::efl::eolian::in_traits<Efl_Text_Font_Bitmap_Scalable>::type scalable) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_TEXT_FONT_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Text_Font *>(this))); }
   operator ::efl::Text_Font() const;
   operator ::efl::Text_Font&();
   operator ::efl::Text_Font const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Text_Font> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Text_Font const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace efl { 
struct Text_Font : private ::efl::eo::concrete
{
   explicit Text_Font( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   Text_Font(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   explicit Text_Font() = default;
   Text_Font(Text_Font const&) = default;
   Text_Font(Text_Font&&) = default;
   Text_Font& operator=(Text_Font const&) = default;
   Text_Font& operator=(Text_Font&&) = default;
   template <typename Derived>
   Text_Font(Derived&& derived
      , typename std::enable_if<
         ::efl::eo::is_eolian_object<Derived>::value
          && std::is_base_of< Text_Font, Derived>::value>::type* = 0)
         : ::efl::eo::concrete(derived._eo_ptr()) {}

   ::efl::eolian::return_traits<void>::type font_get( ::efl::eolian::out_traits< ::efl::eina::string_view>::type font,  ::efl::eolian::out_traits<Efl_Font_Size>::type size) const;
   ::efl::eolian::return_traits<void>::type font_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type font,  ::efl::eolian::in_traits<Efl_Font_Size>::type size) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type font_source_get() const;
   ::efl::eolian::return_traits<void>::type font_source_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type font_source) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type font_fallbacks_get() const;
   ::efl::eolian::return_traits<void>::type font_fallbacks_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type font_fallbacks) const;
   ::efl::eolian::return_traits<Efl_Text_Font_Weight>::type font_weight_get() const;
   ::efl::eolian::return_traits<void>::type font_weight_set( ::efl::eolian::in_traits<Efl_Text_Font_Weight>::type font_weight) const;
   ::efl::eolian::return_traits<Efl_Text_Font_Slant>::type font_slant_get() const;
   ::efl::eolian::return_traits<void>::type font_slant_set( ::efl::eolian::in_traits<Efl_Text_Font_Slant>::type style) const;
   ::efl::eolian::return_traits<Efl_Text_Font_Width>::type font_width_get() const;
   ::efl::eolian::return_traits<void>::type font_width_set( ::efl::eolian::in_traits<Efl_Text_Font_Width>::type width) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type font_lang_get() const;
   ::efl::eolian::return_traits<void>::type font_lang_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type lang) const;
   ::efl::eolian::return_traits<Efl_Text_Font_Bitmap_Scalable>::type font_bitmap_scalable_get() const;
   ::efl::eolian::return_traits<void>::type font_bitmap_scalable_set( ::efl::eolian::in_traits<Efl_Text_Font_Bitmap_Scalable>::type scalable) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_TEXT_FONT_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Text_Font *>(this))); }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Text_Font> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Text_Font const > operator&() const { return {this}; }
   /// @endcond
   ::efl::eo::wref<Text_Font> _get_wref() const { return ::efl::eo::wref<Text_Font>(*this); }
   ::efl::eo::concrete const& _get_concrete() const { return *this; }
   ::efl::eo::concrete& _get_concrete() { return *this; }
   using ::efl::eo::concrete::_eo_ptr;
   using ::efl::eo::concrete::_release;
   using ::efl::eo::concrete::_reset;
   using ::efl::eo::concrete::_delete;
   using ::efl::eo::concrete::operator bool;
#ifdef EFL_CXXPERIMENTAL
   const Text_Font* operator->() const { return this; }
   Text_Font* operator->() { return this; }
   operator Eo*() const { return _eo_ptr(); }
#endif 
   friend bool operator==(Text_Font const& lhs, Text_Font const& rhs)
   { return lhs._get_concrete() == rhs._get_concrete(); }
   friend bool operator!=(Text_Font const& lhs, Text_Font const& rhs)
   { return !(lhs == rhs); }
};
static_assert(sizeof(Text_Font) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Text_Font>::value, "");
} 
#endif
