#ifndef EFL_UI_SCROLLABLE_INTERACTIVE_EO_HH
#define EFL_UI_SCROLLABLE_INTERACTIVE_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_ui_scrollable.eo.h"
#include "efl_ui_scrollable_interactive.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#include "efl_ui_scrollable.eo.hh"
#ifndef EFL_UI_SCROLLABLE_INTERACTIVE_FWD_GUARD
#define EFL_UI_SCROLLABLE_INTERACTIVE_FWD_GUARD
namespace efl { namespace ui { 
struct Scrollable_Interactive;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Scrollable_Interactive> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Scrollable_Interactive&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Scrollable_Interactive const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Scrollable_Interactive const&> : ::std::true_type {}; } }
#endif
#ifndef EFL_UI_SCROLLABLE_FWD_GUARD
#define EFL_UI_SCROLLABLE_FWD_GUARD
namespace efl { namespace ui { 
struct Scrollable;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Scrollable> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Scrollable&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Scrollable const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Scrollable const&> : ::std::true_type {}; } }
#endif

namespace eo_cxx {
namespace efl { namespace ui { 
struct Scrollable_Interactive {
   ::efl::eolian::return_traits<Eina_Position2D>::type content_pos_get() const;
   ::efl::eolian::return_traits<void>::type content_pos_set( ::efl::eolian::in_traits<Eina_Position2D>::type pos) const;
   ::efl::eolian::return_traits<Eina_Size2D>::type content_size_get() const;
   ::efl::eolian::return_traits<Eina_Rect>::type viewport_geometry_get() const;
   ::efl::eolian::return_traits<void>::type bounce_enabled_get( ::efl::eolian::out_traits<bool>::type horiz,  ::efl::eolian::out_traits<bool>::type vert) const;
   ::efl::eolian::return_traits<void>::type bounce_enabled_set( ::efl::eolian::in_traits<bool>::type horiz,  ::efl::eolian::in_traits<bool>::type vert) const;
   ::efl::eolian::return_traits<bool>::type scroll_freeze_get() const;
   ::efl::eolian::return_traits<void>::type scroll_freeze_set( ::efl::eolian::in_traits<bool>::type freeze) const;
   ::efl::eolian::return_traits<bool>::type scroll_hold_get() const;
   ::efl::eolian::return_traits<void>::type scroll_hold_set( ::efl::eolian::in_traits<bool>::type hold) const;
   ::efl::eolian::return_traits<void>::type looping_get( ::efl::eolian::out_traits<bool>::type loop_h,  ::efl::eolian::out_traits<bool>::type loop_v) const;
   ::efl::eolian::return_traits<void>::type looping_set( ::efl::eolian::in_traits<bool>::type loop_h,  ::efl::eolian::in_traits<bool>::type loop_v) const;
   ::efl::eolian::return_traits<Efl_Ui_Scroll_Block>::type movement_block_get() const;
   ::efl::eolian::return_traits<void>::type movement_block_set( ::efl::eolian::in_traits<Efl_Ui_Scroll_Block>::type block) const;
   ::efl::eolian::return_traits<void>::type gravity_get( ::efl::eolian::out_traits<double>::type x,  ::efl::eolian::out_traits<double>::type y) const;
   ::efl::eolian::return_traits<void>::type gravity_set( ::efl::eolian::in_traits<double>::type x,  ::efl::eolian::in_traits<double>::type y) const;
   ::efl::eolian::return_traits<void>::type match_content_set( ::efl::eolian::in_traits<bool>::type w,  ::efl::eolian::in_traits<bool>::type h) const;
   ::efl::eolian::return_traits<void>::type scroll( ::efl::eolian::in_traits<Eina_Rect>::type rect,  ::efl::eolian::in_traits<bool>::type animation) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_SCROLLABLE_INTERACTIVE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Scrollable_Interactive *>(this))); }
   operator ::efl::ui::Scrollable_Interactive() const;
   operator ::efl::ui::Scrollable_Interactive&();
   operator ::efl::ui::Scrollable_Interactive const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Scrollable_Interactive,  ::efl::ui::Scrollable> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Scrollable_Interactive const ,  ::efl::ui::Scrollable const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace ui { 
struct Scrollable_Interactive : private ::efl::eo::concrete
   , EO_CXX_INHERIT(::efl::ui::Scrollable)
{
   explicit Scrollable_Interactive( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   Scrollable_Interactive(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   explicit Scrollable_Interactive() = default;
   Scrollable_Interactive(Scrollable_Interactive const&) = default;
   Scrollable_Interactive(Scrollable_Interactive&&) = default;
   Scrollable_Interactive& operator=(Scrollable_Interactive const&) = default;
   Scrollable_Interactive& operator=(Scrollable_Interactive&&) = default;
   template <typename Derived>
   Scrollable_Interactive(Derived&& derived
      , typename std::enable_if<
         ::efl::eo::is_eolian_object<Derived>::value
          && std::is_base_of< Scrollable_Interactive, Derived>::value>::type* = 0)
         : ::efl::eo::concrete(derived._eo_ptr()) {}

   ::efl::eolian::return_traits<Eina_Position2D>::type content_pos_get() const;
   ::efl::eolian::return_traits<void>::type content_pos_set( ::efl::eolian::in_traits<Eina_Position2D>::type pos) const;
   ::efl::eolian::return_traits<Eina_Size2D>::type content_size_get() const;
   ::efl::eolian::return_traits<Eina_Rect>::type viewport_geometry_get() const;
   ::efl::eolian::return_traits<void>::type bounce_enabled_get( ::efl::eolian::out_traits<bool>::type horiz,  ::efl::eolian::out_traits<bool>::type vert) const;
   ::efl::eolian::return_traits<void>::type bounce_enabled_set( ::efl::eolian::in_traits<bool>::type horiz,  ::efl::eolian::in_traits<bool>::type vert) const;
   ::efl::eolian::return_traits<bool>::type scroll_freeze_get() const;
   ::efl::eolian::return_traits<void>::type scroll_freeze_set( ::efl::eolian::in_traits<bool>::type freeze) const;
   ::efl::eolian::return_traits<bool>::type scroll_hold_get() const;
   ::efl::eolian::return_traits<void>::type scroll_hold_set( ::efl::eolian::in_traits<bool>::type hold) const;
   ::efl::eolian::return_traits<void>::type looping_get( ::efl::eolian::out_traits<bool>::type loop_h,  ::efl::eolian::out_traits<bool>::type loop_v) const;
   ::efl::eolian::return_traits<void>::type looping_set( ::efl::eolian::in_traits<bool>::type loop_h,  ::efl::eolian::in_traits<bool>::type loop_v) const;
   ::efl::eolian::return_traits<Efl_Ui_Scroll_Block>::type movement_block_get() const;
   ::efl::eolian::return_traits<void>::type movement_block_set( ::efl::eolian::in_traits<Efl_Ui_Scroll_Block>::type block) const;
   ::efl::eolian::return_traits<void>::type gravity_get( ::efl::eolian::out_traits<double>::type x,  ::efl::eolian::out_traits<double>::type y) const;
   ::efl::eolian::return_traits<void>::type gravity_set( ::efl::eolian::in_traits<double>::type x,  ::efl::eolian::in_traits<double>::type y) const;
   ::efl::eolian::return_traits<void>::type match_content_set( ::efl::eolian::in_traits<bool>::type w,  ::efl::eolian::in_traits<bool>::type h) const;
   ::efl::eolian::return_traits<void>::type scroll( ::efl::eolian::in_traits<Eina_Rect>::type rect,  ::efl::eolian::in_traits<bool>::type animation) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_SCROLLABLE_INTERACTIVE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Scrollable_Interactive *>(this))); }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Scrollable_Interactive,  ::efl::ui::Scrollable> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Scrollable_Interactive const ,  ::efl::ui::Scrollable const > operator&() const { return {this}; }
   /// @endcond
   ::efl::eo::wref<Scrollable_Interactive> _get_wref() const { return ::efl::eo::wref<Scrollable_Interactive>(*this); }
   ::efl::eo::concrete const& _get_concrete() const { return *this; }
   ::efl::eo::concrete& _get_concrete() { return *this; }
   using ::efl::eo::concrete::_eo_ptr;
   using ::efl::eo::concrete::_release;
   using ::efl::eo::concrete::_reset;
   using ::efl::eo::concrete::_delete;
   using ::efl::eo::concrete::operator bool;
#ifdef EFL_CXXPERIMENTAL
   const Scrollable_Interactive* operator->() const { return this; }
   Scrollable_Interactive* operator->() { return this; }
   operator Eo*() const { return _eo_ptr(); }
#endif 
   friend bool operator==(Scrollable_Interactive const& lhs, Scrollable_Interactive const& rhs)
   { return lhs._get_concrete() == rhs._get_concrete(); }
   friend bool operator!=(Scrollable_Interactive const& lhs, Scrollable_Interactive const& rhs)
   { return !(lhs == rhs); }
};
static_assert(sizeof(Scrollable_Interactive) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Scrollable_Interactive>::value, "");
} } 
#endif
