#ifndef EFL_SELECTION_EO_HH
#define EFL_SELECTION_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_selection.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#ifndef EFL_SELECTION_FWD_GUARD
#define EFL_SELECTION_FWD_GUARD
namespace efl { 
struct Selection;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Selection> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Selection&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Selection const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::Selection const&> : ::std::true_type {}; } }
#endif

namespace eo_cxx {
namespace efl { 
struct Selection {
template <typename F>    ::efl::eolian::return_traits<void>::type selection_get( ::efl::eolian::in_traits<Efl_Selection_Type>::type type,  ::efl::eolian::in_traits<Efl_Selection_Format>::type format, F data_func,  ::efl::eolian::in_traits< unsigned int>::type seat) const;
   ::efl::eolian::return_traits<void>::type selection_clear( ::efl::eolian::in_traits<Efl_Selection_Type>::type type,  ::efl::eolian::in_traits< unsigned int>::type seat) const;
   ::efl::eolian::return_traits<bool>::type has_owner( ::efl::eolian::in_traits<Efl_Selection_Type>::type type,  ::efl::eolian::in_traits< unsigned int>::type seat) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_SELECTION_MIXIN;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Selection *>(this))); }
   operator ::efl::Selection() const;
   operator ::efl::Selection&();
   operator ::efl::Selection const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Selection> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Selection const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace efl { 
struct Selection : private ::efl::eo::concrete
{
   explicit Selection( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   Selection(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   explicit Selection() = default;
   Selection(Selection const&) = default;
   Selection(Selection&&) = default;
   Selection& operator=(Selection const&) = default;
   Selection& operator=(Selection&&) = default;
   template <typename Derived>
   Selection(Derived&& derived
      , typename std::enable_if<
         ::efl::eo::is_eolian_object<Derived>::value
          && std::is_base_of< Selection, Derived>::value>::type* = 0)
         : ::efl::eo::concrete(derived._eo_ptr()) {}

template <typename F>    ::efl::eolian::return_traits<void>::type selection_get( ::efl::eolian::in_traits<Efl_Selection_Type>::type type,  ::efl::eolian::in_traits<Efl_Selection_Format>::type format, F data_func,  ::efl::eolian::in_traits< unsigned int>::type seat) const;
   ::efl::eolian::return_traits<void>::type selection_clear( ::efl::eolian::in_traits<Efl_Selection_Type>::type type,  ::efl::eolian::in_traits< unsigned int>::type seat) const;
   ::efl::eolian::return_traits<bool>::type has_owner( ::efl::eolian::in_traits<Efl_Selection_Type>::type type,  ::efl::eolian::in_traits< unsigned int>::type seat) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_SELECTION_MIXIN;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Selection *>(this))); }
   static struct selection_changed_event
   {
      static Efl_Event_Description const* description()
      { return EFL_SELECTION_EVENT_SELECTION_CHANGED; }
      typedef Efl_Selection_Changed parameter_type;
   } const selection_changed_event;
#ifdef EFL_CXXPERIMENTAL
   template <typename F>
   typename std::enable_if<std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   selection_changed_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(selection_changed_event, *this, function);
   }
   template <typename F>
   typename std::enable_if<!std::is_bind_expression<F>::value, ::efl::eolian::signal_connection>::type
   selection_changed_event_cb_add(F function)
   {
      return ::efl::eolian::event_add(selection_changed_event, *this, std::bind(function));
   }
#endif
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Selection> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Selection const > operator&() const { return {this}; }
   /// @endcond
   ::efl::eo::wref<Selection> _get_wref() const { return ::efl::eo::wref<Selection>(*this); }
   ::efl::eo::concrete const& _get_concrete() const { return *this; }
   ::efl::eo::concrete& _get_concrete() { return *this; }
   using ::efl::eo::concrete::_eo_ptr;
   using ::efl::eo::concrete::_release;
   using ::efl::eo::concrete::_reset;
   using ::efl::eo::concrete::_delete;
   using ::efl::eo::concrete::operator bool;
#ifdef EFL_CXXPERIMENTAL
   const Selection* operator->() const { return this; }
   Selection* operator->() { return this; }
   operator Eo*() const { return _eo_ptr(); }
#endif 
   friend bool operator==(Selection const& lhs, Selection const& rhs)
   { return lhs._get_concrete() == rhs._get_concrete(); }
   friend bool operator!=(Selection const& lhs, Selection const& rhs)
   { return !(lhs == rhs); }
};
static_assert(sizeof(Selection) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Selection>::value, "");
} 
#endif
