#ifndef EFL_UI_CURSOR_EO_HH
#define EFL_UI_CURSOR_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_ui_cursor.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
#ifndef EFL_UI_CURSOR_FWD_GUARD
#define EFL_UI_CURSOR_FWD_GUARD
namespace efl { namespace ui { 
struct Cursor;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Cursor> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Cursor&> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Cursor const> : ::std::true_type {}; } }
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::ui::Cursor const&> : ::std::true_type {}; } }
#endif

namespace eo_cxx {
namespace efl { namespace ui { 
struct Cursor {
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type cursor_get() const;
   ::efl::eolian::return_traits<bool>::type cursor_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type cursor) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type cursor_style_get() const;
   ::efl::eolian::return_traits<bool>::type cursor_style_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
   ::efl::eolian::return_traits<bool>::type cursor_theme_search_enabled_get() const;
   ::efl::eolian::return_traits<bool>::type cursor_theme_search_enabled_set( ::efl::eolian::in_traits<bool>::type allow) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_CURSOR_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Cursor *>(this))); }
   operator ::efl::ui::Cursor() const;
   operator ::efl::ui::Cursor&();
   operator ::efl::ui::Cursor const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Cursor> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Cursor const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace ui { 
struct Cursor : private ::efl::eo::concrete
{
   explicit Cursor( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   Cursor(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   explicit Cursor() = default;
   Cursor(Cursor const&) = default;
   Cursor(Cursor&&) = default;
   Cursor& operator=(Cursor const&) = default;
   Cursor& operator=(Cursor&&) = default;
   template <typename Derived>
   Cursor(Derived&& derived
      , typename std::enable_if<
         ::efl::eo::is_eolian_object<Derived>::value
          && std::is_base_of< Cursor, Derived>::value>::type* = 0)
         : ::efl::eo::concrete(derived._eo_ptr()) {}

   ::efl::eolian::return_traits< ::efl::eina::string_view>::type cursor_get() const;
   ::efl::eolian::return_traits<bool>::type cursor_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type cursor) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type cursor_style_get() const;
   ::efl::eolian::return_traits<bool>::type cursor_style_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type style) const;
   ::efl::eolian::return_traits<bool>::type cursor_theme_search_enabled_get() const;
   ::efl::eolian::return_traits<bool>::type cursor_theme_search_enabled_set( ::efl::eolian::in_traits<bool>::type allow) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_UI_CURSOR_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(reinterpret_cast<Eo **>(const_cast<Cursor *>(this))); }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Cursor> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Cursor const > operator&() const { return {this}; }
   /// @endcond
   ::efl::eo::wref<Cursor> _get_wref() const { return ::efl::eo::wref<Cursor>(*this); }
   ::efl::eo::concrete const& _get_concrete() const { return *this; }
   ::efl::eo::concrete& _get_concrete() { return *this; }
   using ::efl::eo::concrete::_eo_ptr;
   using ::efl::eo::concrete::_release;
   using ::efl::eo::concrete::_reset;
   using ::efl::eo::concrete::_delete;
   using ::efl::eo::concrete::operator bool;
#ifdef EFL_CXXPERIMENTAL
   const Cursor* operator->() const { return this; }
   Cursor* operator->() { return this; }
   operator Eo*() const { return _eo_ptr(); }
#endif 
   friend bool operator==(Cursor const& lhs, Cursor const& rhs)
   { return lhs._get_concrete() == rhs._get_concrete(); }
   friend bool operator!=(Cursor const& lhs, Cursor const& rhs)
   { return !(lhs == rhs); }
};
static_assert(sizeof(Cursor) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Cursor>::value, "");
} } 
#endif
